import json
from mlagents_envs.side_channel.side_channel import (
    SideChannel,
    IncomingMessage,
    OutgoingMessage,
)
import uuid

"""
class that processes information from SideChannel EnvChannel
"""

NEW_TASKS = []


# Create the StringLogChannel class
class PaDChannel(SideChannel):

    def __init__(self) -> None:
        # must coincide with ChannelId set in c#
        super().__init__(uuid.UUID("621f0a70-4f87-11ea-a6bf-784f4387d1f8"))

    def on_message_received(self, msg: IncomingMessage) -> None:
        # We simply read a string from the message and print it.
        data = msg.read_string()
        print(f"Received info from side channel: {data}")
        args = data.split(" ")
        NEW_TASKS.append(args[1:])
        #print(f"New Task({args[1]}, {args[2]}, {args[3]})")

    def send_string(self, data: str) -> None:
        # Add the string to an OutgoingMessage
        msg = OutgoingMessage()
        msg.write_string(data)
        # We call this method to queue the data we want to send
        super().queue_message_to_send(msg)
