import json
from mlagents_envs.side_channel.side_channel import (
    SideChannel,
    IncomingMessage,
    OutgoingMessage,
)
import uuid

import ta_task
from ta_state import Location


class TaskSideChannel(SideChannel):

    def __init__(self) -> None:
        super().__init__(uuid.UUID("c11ab982-82b8-4194-b387-3bd0fe9ebdc7")) #must coincide with ChannelId set in c#
        self.environment_data = None #info on the environment

    # channel receives new tasks that have to be assigned
    def on_message_received(self, msg: IncomingMessage) -> None:
        data = msg.read_string()
        new_task = json.loads(data)
        new_task = new_task["task"]
        task_to_add = ta_task.Task(new_task["TaskId"],
                           Location(new_task["PickUp"]["Column"],
                                    new_task["PickUp"]["Row"], 0),
                           Location(new_task["Delivery"]["Column"], new_task["Delivery"]["Row"], 0),
                                   new_task["ReleaseTime"],
                           None)
        ta_task.CURRENT_TASK_ID += 1
        # task_to_add = ta_task.Task(ta_task.CURRENT_TASK_ID,
        #                    Location(new_task["PickUp"]["Column"],
        #                             new_task["PickUp"]["Row"], 0),
        #                    Location(new_task["Delivery"]["Column"], new_task["Delivery"]["Row"], 0),
        #                            new_task["ReleaseTime"],
        #                    None)
        # ta_task.CURRENT_TASK_ID += 1
        # add task to task to be assigned
        self.environment_data.add_task_to_tasks_to_be_assigned(task_to_add)

    # channel sends information when a task has been assigned (to which robot)
    def send_string(self, data: str) -> None:

        # Add the string to an OutgoingMessage
        msg = OutgoingMessage()
        msg.write_string(data)
        # We call this method to queue the data we want to send
        super().queue_message_to_send(msg)
