"""
Created on Sat Apr 18 10:45:11 2020

@author: Pieter Cawood

"""

def h(pos1, pos2):
    return abs(pos1.col - pos2.col) + abs(pos1.row - pos2.row)

class Location(object):
    def __init__(self, col, row, rotation):
        self.col = col
        self.row = row
        self.rotation = rotation

        # Relevant information for pickup and delivery actions
        self.task_id = None
        self.to_pickup = False
        self.to_deliver = False

    def __eq__(self, other):
        return self.col == other.col and self.row == other.row and self.rotation == other.rotation

    def __hash__(self):
        return hash(str(self.col) + "_" + str(self.row) + "_" + str(self.rotation))

    def __str__(self):
        return str((self.col, self.row, self.rotation))

    # Better information for debugging
    def __repr__(self):
        return f"Location({self.col}, {self.row}, {self.rotation})"


class State(object):
    def __init__(self, time, location):
        self.time = time
        self.location = location
        self.g = 0
        self.f = 0

    def __eq__(self, other):
        return self.time == other.time and self.location == other.location

    def __hash__(self):
        return hash(str(self.time) + str(self.location.col) + str(self.location.row))

    def __str__(self):
        return str((self.time, self.location.col, self.location.row))

    def __lt__(self, other):
        if self.f < other.f:
            return True
        else:
            return False
